function Copy-NetworkFiles {
    [CmdletBinding()]
    param(
        [Parameter(Mandatory=$true)]
        [string]$SourceFolder,
        [Parameter(Mandatory=$true)]
        [string]$DestinationFolder
        )


    $files = Get-ChildItem -Path $SourceFolder
    $Count = $Files.Count
    $i = 1

    foreach ($file in $files)
    {
        Write-Progress -Activity "Copying files" -Status "Copying $file (Item $i of $Count)" -percentComplete ($i / $Count*100)
        Copy-Item -Path $file.FullName -Destination $DestinationFolder -Force -Recurse
        $i++
    }
}