﻿<#
.SYNOPSIS
    Gather monitor serial numbers and models from hosts
.DESCRIPTION
    Extends "\\ntsvr\apps\Admin\Scripts\serial.bat" and "\\ntsvr\apps\Admin\Scripts\monitor_sn.vbs"
    Adds functonality for querying a large amount of hosts either by OU or using a hostnames.txt file
.PARAMETER Hostname
    The hostname
.EXAMPLE
    C:\PS> .\get-monitor.ps1 -Hostname richard
    This will gather all info on connected monitors from host richard
.NOTES
    Author: Hong Zhao
    Date:   Mar 5, 2020    
#>

######################################################################################################
#
#  HONG ZHAO
#  Get-Monitors.PS1
#  Converts "\\ntsvr\apps\Admin\Scripts\monitor_sn.vbs"
#  Adds functonality 
#  Mar 5th, 2020
#
######################################################################################################

function dell( [string]$s ) {
  $info=@{}
  $info.add('C592M','MX-0C592M-72875')
  $info.add('G283H','MX-0G283H-74262')
  $info.add('XTXXK','CN-0XTXXK-72872')
  $info.add('CC302','MX-0CC302-46634')
   if( $s.Length -eq 12 ) {
     $head = $s.Substring(0,5)
     if( $info[$head] ) { 
        $head = $info[$head]
     } else {
        $head = 'CN-0' + $head + '-XXXXX' #fake 
     }
     return $head + '-' + $s.Substring(5,3) + '-' +  $s.Substring(8,4)
   }
   else {
     return $s

   }
}

function Get-Monitor
{

    #Defining command line params
    param (
        [string]$ComputerName
    )

    $monitor = "\\ntsvr\apps\admin\scripts\monitor_sn.vbs"
    $m=@()

    & cscript /nologo $monitor $ComputerName | foreach {
          $model,$serial = $_.split(":")[0,1]
          $s=""|select model,serial
          $s.model = $model; 
          $s.serial = dell $serial.trim()
          $m += $s
    }

  return $m
}
