function get-opennetworkdrive

{
    $alphabet = @()  
    
    for ([byte]$c = [char]'A'; $c -le [char]'Z'; $c++)  
    {  
        $alphabet += [char]$c  
    }  

    $taken_drives = get-psdrive -PSProvider FileSystem
    $available_drives = @()
    $letters = @()
    $drive_letters = @()

    foreach ($letter in $alphabet)
    {
        $let = $letter.ToString()
        $letters += $let
    }

    foreach ($letter in $taken_drives)
    {
        $let = $letter.name.ToString()
        $drive_letters += $let
    }

    foreach ($let in $letters)
    {
        if ($drive_letters -notcontains $let)
        {
            $available_drives += $let
        }
    }
    [array]::Reverse($available_drives)
    $chosen_letter = $available_drives[0]


    $openpath = $chosen_letter + ":"

    return $openpath
}   
