﻿<#
.SYNOPSIS
    A PowerShell fast test TCP port, replace Test-NetConnection 

.DESCRIPTION
    
    
.PARAMETER ComputerName
    computer name or ip
    
.PARAMETER Port
    port number


.EXAMPLE
    Test-Port localhost 7680
.NOTES
    Author: Hong Zhao
    Date:   May 6, 2020   
#>

function Test-Port {
param (
        [Parameter(Mandatory=$true)]
        [ValidateNotNullOrEmpty()]
        [string]$ComputerName,
        [Parameter(Mandatory=$true)]
        [ValidateNotNullOrEmpty()]
        [string]$Port,
        [string]$timeout=100
    )


  $requestCallback = $state = $null
  $client = New-Object System.Net.Sockets.TcpClient
  $beginConnect = $client.BeginConnect($ComputerName,$port,$requestCallback,$state)
  Start-Sleep -milli $timeOut
  if ($client.Connected) { $open = $true } else { $open = $false }
  $client.Close()
  [pscustomobject]@{ComputerName=$ComputerName;Port=$Port;Open=$open}
}